Subject: RE: draft-ietf-tn5250e-02.txt

From: [email-masked] (Paul Tykodi)
Date: Thu, 7 May 1998 12:56:41 -0400

Jeffrey Stevens wrote to the TN3270E mailing list:

Hello Everyone,

This is a refreshed draft which includes a little reorganization
and more detail.  Some major changes include the following:
<text of draft removed>

Dear Jeffrey,

I have some questions about the printer support of TN5250E.

1. The printing example in the draft RFC is using the AS/400 feature Host Print Transform to convert the AS/400 EBCDIC data to ASCII data on the AS/400 before sending the information to the sample TN5250E client. I am interested in the other possible scenario where the IBMTRANSFORM parameter is set to NO. In this case EBCDIC data is transferred directly from the AS/400 to the target TN5250E print client. My first question is about the current implementation of the TN5250E server support in OS/400. Does it support the IBMTRANSFORM NO selection?

2. Assuming that it is possible for a TN5250E print client to receive EBCDIC data, I see a potential problem with the current printer terminal type selections available.

The problem is that different models of IBM midrange compatible printers (SBCS) support different sets of SCS control codes. Some examples are as follows:

Most all IBM Midrange Compatible SBCS Printers Support These Control Codes

Code    Value                           Description

ATRN    03nn                            ASCII Transparency
FF              0C                              Form Feed
CR              0D                              Carriage Return
NL              15                              New Line
IRS             1E                              Interchange Record Separator
LF              25                              Line Feed
SHF     2BC1nnhh                        Set Horizontal Format
SVF     2BC2nnvv                        Set Vertical Format
SLD     2BC6nnld                        Set Line Density
SGEA    2BC8nngguu                      Set Graphic Error Action
SCGL    2BD10381id                      Set Char. Set through Local ID
SSLD    2BD20415ldld                    Set Single Line Distance
SCD     2BD20429cp                      Set Character Density
BEL     2F                              Bell
AHPP    34C0ah                          Absolute Hor. Presentation Pos.
AVPP    34C4av                          Absolute Vert. Presentation Pos.
RHPP    34C8rh                          Relative Hor. Presentation Pos.
RVPP    344Crv                          Relative Vert. Presentation Pos.
TRN     35nn                            Transparent
SP              40                              Space
RSP     41                              Required Space
RHY     60                              Required Hyphen
US              6D                              Underscore
SHY     CA                              Syllable Hyphen

Some IBM Midrange Compatible SBCS Printers support the Page Presentation Media command because they offer multiple input paper drawers or multiple output stacker destinations.

Some of the matrix printer models support the Load Alternate Characters Command for receiving raster graphic information.

A very few IBM Midrange Compatible SBCS Printers support the Final Form Text - Document Content Architecture commands (ex. 3812 and 5219) that provide word processing capabilities such as font selection, control of margins, and the ability to justify and center text.

One of the benefits of using the SNA data stream, rather than the Host Print Transform equivalence, between the AS/400 and the TN5250E client is the significantly improved spool file management, messaging, and error determination capabilities.

As an example, if a vendor were to produce a TN5250E client that offered a 5256 emulation (10 CPI only, also supports 6 and 8 lpi), I would expect that this client would currently be unable to print anything because it would send back errors due to the 3812 formatting received. My expectation is that the errors reported by the print client would produce the "Attributes of spool file unsupported by target device" message on the AS/400.

If the answer to question 1 is that it is possible for EBCDIC data to flow to a TN5250E print client, I am wondering whether it would be possible to negotiate the list of standard SCS control commands (like the example list above) that would be released by the AS/400 server to all print clients?

If this request were acted upon favorably, a small number of Telnet sub-negotiation commands would then have to be defined to allow TN5250E print clients to describe to the AS/400 server the other features that they supported beyond the basic command set.

Overall I think the draft RFC is very useful. Thank you for making this significant effort to improve the functionality of the TN5250 specification.

/Paul
--
Paul Tykodi, Technical Director                 E-mail: [email-masked]
Praim Inc.                                           Tel: 603-431-0606
140 Congress St., #2                                Fax: 603-436-6432
Portsmouth, NH  03801-4019